--[[
  [DOM] Versão de 08/04/2013 (Version from 04/08/2013)
  - Convertendo referências de technic:diamond para default:diamond (Converting references from technic:diamond to default:diamond)

  [DOM] Versão de 23/03/2013 (Version from 03/23/2013)
  - Adicionadas imagens para os diamantes.  (Adding more diamond images)
  - Dono do mod notificado das alterações através do fórum (Added a post in the forum topic about the modification of this mod)
  - Adicionada conversão entre technic:diamond <-> diamonds:diamond_pure (Added conversion thecnic:diamond <-> diamonds:diamond_pure)

]]--
--+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
--Diamonds by InfinityProject                                                         +
--                                                                                    +
--LICENSE: WTFPL DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE; applies to all parts.   +
--                                                                                    +
--Please give any ideas on ways to improve this mod!                                  +
--+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

minetest.register_alias("diamonds:diamond","diamonds:diamond_stone")

minetest.register_node("diamonds:diamond_in_ground", {
  description = "Stone with diamonds",
  tile_images = { "default_stone.png^diamond_in_ground.png" },
  is_ground_content = true,
  groups = {cracky=3},
  sounds = default.node_sound_stone_defaults(),
  drop = 'craft "diamonds:diamond_stone" 1',
})

--[[minetest.register_node("diamonds:block", {
  description = "Block of diamonds",
  tile_images = { "diamond_block.png" },
  is_ground_content = true,
  groups = {cracky=3},
  sounds = default.node_sound_stone_defaults(),
})
--]]
minetest.register_craftitem("diamonds:diamond_stone", {
  description = "Stone with diamonds",
  inventory_image = "diamonds_stone.png",
  on_place_on_ground = minetest.craftitem_place_item,
})

minetest.register_craftitem("diamonds:diamond_raw", {
  description = "Diamond (raw)",
  inventory_image = "diamonds_raw.png",
  on_place_on_ground = minetest.craftitem_place_item,
})


minetest.register_craftitem("diamonds:diamond_pure", {
  description = "Diamond (pure)",
  inventory_image = "diamonds_pure.png",
        tile_images = {"diamonds_raw.png"},
  on_place_on_ground = minetest.craftitem_place_item,
})

minetest.register_tool("diamonds:shovel", {
  description = "Diamond Shovel",
  inventory_image = "diamond_shovel.png",
  tool_capabilities = {
    max_drop_level=1,
    groupcaps={
      crumbly={times={[1]=1.50, [2]=0.70, [3]=0.60}, uses=500, maxlevel=2}
    }
  },
})

minetest.register_tool("diamonds:pick", {
  description = "Diamond Pickaxe",
  inventory_image = "diamond_pick.png",
  tool_capabilities = {
    full_punch_interval = 1.0,
    max_drop_level=3,
    groupcaps={
      cracky={times={[1]=2.0, [2]=1.0, [3]=0.5}, uses=500, maxlevel=3},
      crumbly={times={[1]=2.0, [2]=1.0, [3]=0.5}, uses=600, maxlevel=3},
      snappy={times={[1]=2.0, [2]=1.0, [3]=0.5}, uses=550, maxlevel=3}
    }
  },
})



--
--Crafting
--

--Para permitir conversão dos diamantes comuns em puros e vice-versa.
minetest.register_craft({
  output = 'diamonds:diamond_raw',
  recipe = {
    {'', 'default:diamond', ''},
    {'default:diamond', 'default:diamond', 'default:diamond'},
    {'', 'default:diamond', ''},}
})

minetest.register_craft({
  output = 'diamonds:diamond_raw',
  recipe = {
    {'', 'diamonds:diamond_pure', ''},
    {'diamonds:diamond_pure', 'diamonds:diamond_pure', 'diamonds:diamond_pure'},
    {'', 'diamonds:diamond_pure', ''},}
})

minetest.register_craft({
  output = 'diamonds:diamond_raw 1',
  recipe = {{'diamonds:diamond_stone',},}
})

minetest.register_craft({
  output = 'diamonds:diamond_pure 5',
  recipe = {{'diamonds:diamond_raw',},}
})

minetest.register_craft({
  output = 'default:diamond',
  recipe = {{'diamonds:diamond_pure',},}
})

minetest.register_craft({
  output = 'diamonds:diamond_pure',
  recipe = {{'default:diamond',},}
})





--
--Generation
--


local function generate_ore(name, wherein, minp, maxp, seed, chunks_per_volume, ore_per_chunk, height_min, height_max)
  if maxp.y < height_min or minp.y > height_max then
    return
  end
  local y_min = math.max(minp.y, height_min)
  local y_max = math.min(maxp.y, height_max)
  local volume = (maxp.x-minp.x+1)*(y_max-y_min+1)*(maxp.z-minp.z+1)
  local pr = PseudoRandom(seed)
  local num_chunks = math.floor(chunks_per_volume * volume)
  local chunk_size = 3
  if ore_per_chunk <= 4 then
    chunk_size = 2
  end
  local inverse_chance = math.floor(chunk_size*chunk_size*chunk_size / ore_per_chunk)
  --print("generate_ore num_chunks: "..dump(num_chunks))
  for i=1,num_chunks do
    local y0 = pr:next(y_min, y_max-chunk_size+1)
    if y0 >= height_min and y0 <= height_max then
      local x0 = pr:next(minp.x, maxp.x-chunk_size+1)
      local z0 = pr:next(minp.z, maxp.z-chunk_size+1)
      local p0 = {x=x0, y=y0, z=z0}
      for x1=0,chunk_size-1 do
      for y1=0,chunk_size-1 do
      for z1=0,chunk_size-1 do
        if pr:next(1,inverse_chance) == 1 then
          local x2 = x0+x1
          local y2 = y0+y1
          local z2 = z0+z1
          local p2 = {x=x2, y=y2, z=z2}
          if minetest.env:get_node(p2).name == wherein then
            minetest.env:set_node(p2, {name=name})
          end
        end
      end
      end
      end
    end
  end
end

minetest.register_on_generated(function(minp, maxp, seed)
generate_ore("diamonds:diamond_in_ground", "default:stone", minp, maxp, seed+20,   1/13/13/13,    2, -31000,  -300)
end)

-- Apenas para indicar que este módulo foi completamente carregado.
DOM_mb(minetest.get_current_modname(),minetest.get_modpath(minetest.get_current_modname()))
